3 # Copyright (c) 2005 Junio C Hamano.
6 USAGE
='[--interactive | -i] [-v] [--onto <newbase>] <upstream> [<branch>]'
7 LONG_USAGE
='git-rebase replaces <branch> with a new branch of the
8 same name. When the --onto option is provided the new branch starts
9 out with a HEAD equal to <newbase>, otherwise it is equal to <upstream>
10 It then attempts to create a new commit for each commit from the original
11 <branch> that does not exist in the <upstream> branch.
13 It is possible that a merge failure will prevent this process from being
14 completely automatic. You will have to resolve any such merge failure
15 and run git rebase --continue. Another option is to bypass the commit
16 that caused the merge failure with git rebase --skip. To restore the
17 original <branch> and remove the .dotest working files, use the command
18 git rebase --abort instead.
20 Note that if <branch> is not specified on the command line, the
21 currently checked out branch is used.
23 Example: git-rebase master~1 topic
25 A---B---C topic A'\''--B'\''--C'\'' topic
27 D---E---F---G master D---E---F---G master
33 set_reflog_action rebase
38 When you have resolved this problem run \"git rebase --continue\".
39 If you would prefer to skip this patch, instead run \"git rebase --skip\".
40 To restore the original branch and stop rebasing run \"git rebase --abort\".
45 dotest
=$GIT_DIR/.dotest-merge
51 test -n "$prev_head" || die
"prev_head must be defined"
52 test -d "$dotest" || die
"$dotest directory does not exist"
54 unmerged
=$
(git ls-files
-u)
55 if test -n "$unmerged"
57 echo "You still have unmerged paths in your index"
58 echo "did you forget to use git add?"
62 cmt
=`cat "$dotest/current"`
63 if ! git diff-index
--quiet --ignore-submodules HEAD
--
65 if ! git commit
--no-verify -C "$cmt"
67 echo "Commit failed, please do not call \"git commit\""
68 echo "directly, but instead do one of the following: "
71 printf "Committed: %0${prec}d " $msgnum
73 printf "Already applied: %0${prec}d " $msgnum
75 git rev-list
--pretty=oneline
-1 "$cmt" |
sed -e 's/^[^ ]* //'
77 prev_head
=`git rev-parse HEAD^0`
78 # save the resulting commit so we can read-tree on it later
79 echo "$prev_head" > "$dotest/prev_head"
81 # onto the next patch:
82 msgnum
=$
(($msgnum + 1))
83 echo "$msgnum" >"$dotest/msgnum"
87 cmt
="$(cat "$dotest/cmt.
$1")"
88 echo "$cmt" > "$dotest/current"
89 hd
=$
(git rev-parse
--verify HEAD
)
90 cmt_name
=$
(git symbolic-ref HEAD
2> /dev
/null ||
echo HEAD
)
91 msgnum
=$
(cat "$dotest/msgnum")
92 end
=$
(cat "$dotest/end")
93 eval GITHEAD_
$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
94 eval GITHEAD_
$hd='$(cat "$dotest/onto_name")'
95 export GITHEAD_
$cmt GITHEAD_
$hd
96 git-merge-
$strategy "$cmt^" -- "$hd" "$cmt"
100 unset GITHEAD_
$cmt GITHEAD_
$hd
108 echo "Strategy: $rv $strategy failed, try another" 1>&2
112 die
"Unknown exit code ($rv) from command:" \
113 "git-merge-$strategy $cmt^ -- HEAD $cmt"
118 move_to_original_branch
() {
119 test -z "$head_name" &&
120 head_name
="$(cat "$dotest"/head-name)" &&
121 onto
="$(cat "$dotest"/onto)" &&
122 orig_head
="$(cat "$dotest"/orig-head)"
125 message
="rebase finished: $head_name onto $onto"
126 git update-ref
-m "$message" \
127 $head_name $
(git rev-parse HEAD
) $orig_head &&
128 git symbolic-ref HEAD
$head_name ||
129 die
"Could not move back to $head_name"
135 move_to_original_branch
141 test -f "$dotest"/interactive ||
142 while :; do case $#,"$1" in 0,|
*,-i|
*,--interactive) break ;; esac
147 is_interactive
"$@" && exec git-rebase--interactive
"$@"
153 git diff-files
--quiet --ignore-submodules ||
{
154 echo "You must edit all merge conflicts and then"
155 echo "mark them as resolved using git add"
160 prev_head
=$
(cat "$dotest/prev_head")
161 end
=$
(cat "$dotest/end")
162 msgnum
=$
(cat "$dotest/msgnum")
163 onto
=$
(cat "$dotest/onto")
165 while test "$msgnum" -le "$end"
173 head_name
=$
(cat .dotest
/head-name
) &&
174 onto
=$
(cat .dotest
/onto
) &&
175 orig_head
=$
(cat .dotest
/orig-head
) &&
176 git am
--resolved --3way --resolvemsg="$RESOLVEMSG" &&
177 move_to_original_branch
181 git
reset --hard HEAD ||
exit $?
185 prev_head
=$
(cat "$dotest/prev_head")
186 end
=$
(cat "$dotest/end")
187 msgnum
=$
(cat "$dotest/msgnum")
188 msgnum
=$
(($msgnum + 1))
189 onto
=$
(cat "$dotest/onto")
190 while test "$msgnum" -le "$end"
198 head_name
=$
(cat .dotest
/head-name
) &&
199 onto
=$
(cat .dotest
/onto
) &&
200 orig_head
=$
(cat .dotest
/orig-head
) &&
201 git am
-3 --skip --resolvemsg="$RESOLVEMSG" &&
202 move_to_original_branch
209 move_to_original_branch
213 move_to_original_branch
215 die
"No rebase in progress?"
217 git
reset --hard $
(cat "$dotest/orig-head")
222 test 2 -le "$#" || usage
226 -M|
-m|
--m|
--me|
--mer|
--merg|
--merge)
229 -s=*|
--s=*|
--st=*|
--str=*|
--stra=*|
--strat=*|
--strate=*|\
230 --strateg=*|
--strategy=*|\
231 -s|
--s|
--st|
--str|
--stra|
--strat|
--strate|
--strateg|
--strategy)
234 strategy
=`expr "z$1" : 'z-[^=]*=\(.*\)'` ;;
247 git_am_opt
="$git_am_opt $1"
250 git_am_opt
="$git_am_opt $1"
262 # Make sure we do not have .dotest
263 if test -z "$do_merge"
270 It seems that I cannot create a .dotest directory, and I wonder if you
271 are in the middle of patch application or another rebase. If that is not
272 the case, please rm -fr .dotest and run me again. I am stopping in case
273 you still have something valuable there.'
279 die
"previous dotest directory $dotest still exists." \
280 'try git-rebase < --continue | --abort >'
284 # The tree must be really really clean.
285 git update-index
--ignore-submodules --refresh ||
exit
286 diff=$
(git diff-index
--cached --name-status -r --ignore-submodules HEAD
--)
288 ?
*) echo "cannot rebase: your index is not up-to-date"
294 # The upstream head must be given. Make sure it is valid.
296 upstream
=`git rev-parse --verify "${upstream_name}^0"` ||
297 die
"invalid upstream $upstream_name"
299 # Make sure the branch to rebase onto is valid.
300 onto_name
=${newbase-"$upstream_name"}
301 onto
=$
(git rev-parse
--verify "${onto_name}^0") ||
exit
303 # If a hook exists, give it a chance to interrupt
304 if test -x "$GIT_DIR/hooks/pre-rebase"
306 "$GIT_DIR/hooks/pre-rebase" ${1+"$@"} ||
{
307 echo >&2 "The pre-rebase hook refused to rebase."
312 # If the branch to rebase is given, that is the branch we will rebase
313 # $branch_name -- branch being rebased, or HEAD (already detached)
314 # $orig_head -- commit object name of tip of the branch before rebasing
315 # $head_name -- refs/heads/<that-branch> or "detached HEAD"
319 # Is it "rebase other $branchname" or "rebase other $commit"?
323 if git show-ref
--verify --quiet -- "refs/heads/$2" &&
324 branch
=$
(git rev-parse
--verify "refs/heads/$2" 2>/dev
/null
)
326 head_name
="refs/heads/$2"
327 elif branch
=$
(git rev-parse
--verify "$2" 2>/dev
/null
)
329 head_name
="detached HEAD"
335 # Do not need to switch branches, we are already on it.
336 if branch_name
=`git symbolic-ref -q HEAD`
338 head_name
=$branch_name
339 branch_name
=`expr "z$branch_name" : 'zrefs/heads/\(.*\)'`
341 head_name
="detached HEAD"
342 branch_name
=HEAD
;# detached
344 branch
=$
(git rev-parse
--verify "${branch_name}^0") ||
exit
349 # Now we are rebasing commits $upstream..$branch on top of $onto
351 # Check if we are already based on $onto with linear history,
352 # but this should be done only when upstream and onto are the same.
353 mb
=$
(git merge-base
"$onto" "$branch")
354 if test "$upstream" = "$onto" && test "$mb" = "$onto" &&
356 ! (git rev-list
--parents "$onto"..
"$branch" |
grep " .* ") > /dev
/null
358 # Lazily switch to the target branch if needed...
359 test -z "$switch_to" || git checkout
"$switch_to"
360 echo >&2 "Current branch $branch_name is up to date."
364 if test -n "$verbose"
366 echo "Changes from $mb to $onto:"
367 # We want color (if set), but no pager
368 GIT_PAGER
='' git
diff --stat --summary "$mb" "$onto"
371 # Detach HEAD and reset the tree
372 echo "First, rewinding head to replay your work on top of it..."
373 git checkout
"$onto^0" >/dev
/null
2>&1 ||
374 die
"could not detach HEAD"
375 # git reset --hard "$onto^0"
377 # If the $onto is a proper descendant of the tip of the branch, then
378 # we just fast forwarded.
379 if test "$mb" = "$branch"
381 echo >&2 "Fast-forwarded $branch_name to $onto_name."
382 move_to_original_branch
386 if test -z "$do_merge"
388 git format-patch
-k --stdout --full-index --ignore-if-in-upstream \
389 "$upstream..$orig_head" |
390 git am
$git_am_opt --rebasing --resolvemsg="$RESOLVEMSG" &&
391 move_to_original_branch
393 test 0 != $ret -a -d .dotest
&&
394 echo $head_name > .dotest
/head-name
&&
395 echo $onto > .dotest
/onto
&&
396 echo $orig_head > .dotest
/orig-head
400 # start doing a rebase with git-merge
401 # this is rename-aware if the recursive (default) strategy is used
404 echo "$onto" > "$dotest/onto"
405 echo "$onto_name" > "$dotest/onto_name"
407 echo "$prev_head" > "$dotest/prev_head"
408 echo "$orig_head" > "$dotest/orig-head"
409 echo "$head_name" > "$dotest/head-name"
412 for cmt
in `git rev-list --reverse --no-merges "$upstream..$orig_head"`
414 msgnum
=$
(($msgnum + 1))
415 echo "$cmt" > "$dotest/cmt.$msgnum"
418 echo 1 >"$dotest/msgnum"
419 echo $msgnum >"$dotest/end"
424 while test "$msgnum" -le "$end"